﻿Imports System.Text
Imports System.ComponentModel
Imports Telerik.WinControls
Imports Telerik.WinControls.UI


Public Class CustomListDataItem
    Inherits RadListDataItem
    Public Event Changed As ChangedEventHandler

    Public Sub New()
        AddHandler PropertyChanged, AddressOf item_PropertyChanged
    End Sub

    Public Sub New(ByVal text As String)
        MyBase.New(text)
        AddHandler PropertyChanged, AddressOf item_PropertyChanged
    End Sub

    Public Shared ReadOnly CheckedProperty As RadProperty = RadProperty.Register("Checked", GetType(Boolean), GetType(CustomListDataItem), New RadElementPropertyMetadata(False))
    Public Shared ReadOnly NameProperty As RadProperty = RadProperty.Register("Name", GetType(String), GetType(CustomListDataItem), New RadElementPropertyMetadata(""))

    Public Property Checked() As Boolean
        Get
            Return CBool(Me.GetValue(CustomListDataItem.CheckedProperty))
        End Get
        Set(ByVal value As Boolean)
            Me.SetValue(CustomListDataItem.CheckedProperty, value)
        End Set
    End Property

    Public Property Name() As String
        Get
            Return CStr(Me.GetValue(CustomListDataItem.NameProperty))
        End Get
        Set(ByVal value As String)
            Me.SetValue(CustomListDataItem.NameProperty, value)
        End Set
    End Property

    Protected Overridable Sub OnSelectedItemChanged(ByVal e As ItemsChangedEventArgs)
        RaiseEvent Changed(Me, e)
    End Sub

    Private Sub item_PropertyChanged(ByVal sender As Object, ByVal e As PropertyChangedEventArgs)
        If e.PropertyName = "Checked" Then
            Dim ddlControl As RadMultiSelectDropDownList = CType((CType(Me.Owner.ElementTree.Control, DropDownPopupForm)).OwnerDropDownListElement.ElementTree.Control, RadMultiSelectDropDownList)
            ddlControl.SetText()

            If Me.Checked Then
                OnSelectedItemChanged(New ItemsChangedEventArgs(Me, ItemsChangeOperation.Inserted))
            Else
                OnSelectedItemChanged(New ItemsChangedEventArgs(Me, ItemsChangeOperation.Removed))
            End If
        End If
    End Sub
End Class

