﻿Imports Telerik.WinControls.UI
Imports Telerik.WinControls
Imports Telerik.WinControls.Layouts


Public Class CustomListVisualItem
    Inherits RadListVisualItem

    Private label As RadLabelElement
    Private checkBox As RadCheckBox
    Private host As RadHostItem

    Shared Sub New()
        RadListVisualItem.SynchronizationProperties.Add(CustomListDataItem.CheckedProperty)
        RadListVisualItem.SynchronizationProperties.Add(CustomListDataItem.NameProperty)
    End Sub

    Protected Overrides ReadOnly Property ThemeEffectiveType() As Type
        Get
            Return GetType(RadListVisualItem)
        End Get
    End Property

    Protected Overrides Sub CreateChildElements()
        MyBase.CreateChildElements()

        checkBox = New RadCheckBox()
        label = New RadLabelElement()
        Me.host = New RadHostItem(checkBox)
        AddHandler Me.checkBox.ToggleStateChanged, AddressOf ToggleStateChanged
        Me.label.StretchHorizontally = True
        Me.label.Margin = New Padding(15, 0, 0, 0)
        Me.host.Margin = New Padding(0, 1, 0, 0)
        Dim stack As New StackLayoutPanel()
        stack.Orientation = Orientation.Horizontal
        stack.Children.Add(host)
        stack.Children.Add(label)
        Me.Children.Add(stack)
    End Sub

    Protected Overrides Sub PropertySynchronized(ByVal [property] As RadProperty)
        Dim dataItem As CustomListDataItem = CType(Me.Data, CustomListDataItem)

        If [property] Is CustomListDataItem.CheckedProperty Then
            Dim newValue As Boolean = dataItem.Checked

            Me.checkBox.Checked = newValue

            Dim itemName As String = dataItem.Text
            Me.label.Text = Me.GetAvailabilityText(itemName, newValue)
        End If

        If [property] Is CustomListDataItem.NameProperty Then
            Dim itemName As String = dataItem.Text
            Dim available As Boolean = dataItem.Checked
            Me.label.Text = Me.GetAvailabilityText(itemName, available)
        End If

        Me.Text = ""
        Dim ddlControl As RadMultiSelectDropDownList = DirectCast(DirectCast(Me.ElementTree.Control, DropDownPopupForm).OwnerDropDownListElement.ElementTree.Control, RadMultiSelectDropDownList)
        ddlControl.SetText()
    End Sub

    Private Function GetAvailabilityText(ByVal itemName As String, ByVal available As Boolean) As String
        Dim yesno As String = If(available, " ", " not ")
        Return itemName & " is" & yesno & "checked"
    End Function

    Private Sub ToggleStateChanged(ByVal sender As Object, ByVal args As StateChangedEventArgs)
        CType(Me.Data, CustomListDataItem).Checked = Me.checkBox.Checked
    End Sub
End Class

