﻿Imports System.Text
Imports System.Collections

Public Class MyDynamicCollection
    Implements IList(Of CustomListDataItem)
    Private owner As RadMultiSelectDropDownList

    Public Sub New(ByVal owner As RadMultiSelectDropDownList)
        Me.owner = owner
    End Sub

    Public Sub Add(ByVal item As CustomListDataItem) Implements ICollection(Of CustomListDataItem).Add
        item.Checked = True
    End Sub

    Public Sub Clear() Implements ICollection(Of CustomListDataItem).Clear
        For i As Integer = 0 To owner.Items.Count - 1
            CType(owner.Items(i), CustomListDataItem).Checked = False
        Next i
    End Sub

    Public Function Contains(ByVal item As CustomListDataItem) As Boolean Implements ICollection(Of CustomListDataItem).Contains
        For i As Integer = 0 To owner.Items.Count - 1
            If (CType(owner.Items(i), CustomListDataItem)).Checked Then
                If owner.Items(i) Is item Then
                    Return True
                End If
            End If
        Next i

        Return False
    End Function

    Public Sub CopyTo(ByVal array() As CustomListDataItem, ByVal arrayIndex As Integer) Implements System.Collections.Generic.IList(Of CustomListDataItem).CopyTo
        Throw New NotImplementedException()
    End Sub

    Public ReadOnly Property Count() As Integer Implements ICollection(Of CustomListDataItem).Count
        Get
            Dim counter As Integer = 0

            For i As Integer = 0 To owner.Items.Count - 1
                If (CType(owner.Items(i), CustomListDataItem)).Checked Then
                    counter += 1
                End If
            Next i

            Console.WriteLine(owner.Items(0).Selected & " " & owner.Items(1).Selected & " " & owner.Items(2).Selected & " " & owner.Items(3).Selected & " " & owner.Items(4).Selected)
            Console.WriteLine("SelectedItems Count " & counter)
            Return counter
        End Get
    End Property

    Public ReadOnly Property IsReadOnly() As Boolean Implements ICollection(Of CustomListDataItem).IsReadOnly
        Get
            Return False
        End Get
    End Property

    Public Function Remove(ByVal item As CustomListDataItem) As Boolean Implements ICollection(Of CustomListDataItem).Remove
        item.Checked = False

        Return True
    End Function

    Public Function GetEnumerator() As IEnumerator(Of CustomListDataItem) Implements IEnumerable(Of CustomListDataItem).GetEnumerator
        Return New MyCollectionEnumerator(owner, Me)
    End Function

    Private Function IEnumerable_GetEnumerator() As System.Collections.IEnumerator Implements System.Collections.IEnumerable.GetEnumerator
        Return New MyCollectionEnumerator(owner, Me)
    End Function

    Public Function IndexOf(ByVal item As CustomListDataItem) As Integer Implements IList(Of CustomListDataItem).IndexOf
        Dim counter As Integer = 0

        For i As Integer = 0 To owner.Items.Count - 1
            If (CType(owner.Items(i), CustomListDataItem)).Checked Then
                If owner.Items(i) Is item Then
                    Return counter
                End If

                counter += 1
            End If
        Next i

        Return -1
    End Function

    Public Sub Insert(ByVal index As Integer, ByVal item As CustomListDataItem) Implements IList(Of CustomListDataItem).Insert
        ' throw new NotImplementedException();
    End Sub

    Public Sub RemoveAt(ByVal index As Integer) Implements IList(Of CustomListDataItem).RemoveAt
        Dim counter As Integer = 0
        Dim itemToBeRemoved As CustomListDataItem = Nothing

        For i As Integer = 0 To owner.Items.Count - 1
            If (CType(owner.Items(i), CustomListDataItem)).Checked Then
                If counter = index Then
                    itemToBeRemoved = CType(owner.Items(i), CustomListDataItem)
                    CType(owner.Items(i), CustomListDataItem).Checked = False
                End If

                counter += 1
            End If
        Next i
    End Sub

    Default Public Property Item(ByVal index As Integer) As CustomListDataItem Implements System.Collections.Generic.IList(Of CustomListDataItem).Item

        Get
            Dim counter As Integer = 0

            For i As Integer = 0 To owner.Items.Count - 1
                If (CType(owner.Items(i), CustomListDataItem)).Checked Then
                    If counter = index Then
                        Return CType(owner.Items(i), CustomListDataItem)
                    End If

                    counter += 1
                End If
            Next i

            Throw New IndexOutOfRangeException()
        End Get
        Set(ByVal value As CustomListDataItem)
            Dim counter As Integer = 0

            For i As Integer = 0 To owner.Items.Count - 1
                If (CType(owner.Items(i), CustomListDataItem)).Checked Then
                    If counter = index Then
                        owner.Items(i) = value
                    End If

                    counter += 1
                End If
            Next i

            Throw New IndexOutOfRangeException()
        End Set
    End Property

    Public Overrides Function ToString() As String
        Dim selectedItems As String = String.Empty
        For i As Integer = 0 To Me.Count - 1
            selectedItems &= Me(i).Text & " "
        Next i

        Return selectedItems
    End Function
End Class
